%define ocamlname parsexp

Name:           ocaml-%{ocamlname}
Version:        0.10.0
Release:        1%{?dist}.emp1
Summary:        S-expression parsing library
License:        Apache-2.0
URL:            https://github.com/janestreet/%{ocamlname}
Source0:        %{ocamlname}-v%{version}.tar.gz

Requires:       ocaml >= 4.04.1
Requires: 	ocaml-base >= 0.10
Requires: 	ocaml-base < 0.11
Requires: 	ocaml-ppx_compare >= 0.10
Requires: 	ocaml-ppx_compare < 0.11
Requires: 	ocaml-ppx_driver >= 0.10
Requires:	ocaml-ppx_driver < 0.11
Requires: 	ocaml-ppx_fields_conv >= 0.10
Requires: 	ocaml-ppx_fields_conv < 0.11
Requires: 	ocaml-ppx_js_style >= 0.10
Requires: 	ocaml-ppx_js_style < 0.11
Requires: 	ocaml-ppx_sexp_conv >= 0.10
Requires: 	ocaml-ppx_sexp_conv < 0.11
Requires: 	ocaml-ppx_sexp_value >= 0.10
Requires: 	ocaml-ppx_sexp_value < 0.11
Requires: 	ocaml-ocaml-migrate-parsetree >= 0.4

BuildRequires:  opam-installer >= 2.0
BuildRequires:  ocaml >= 4.04.1
BuildRequires:  jbuilder
BuildRequires: 	ocaml-base-devel >= 0.10
BuildRequires: 	ocaml-base-devel < 0.11
BuildRequires: 	ocaml-ppx_compare-devel >= 0.10
BuildRequires: 	ocaml-ppx_compare-devel < 0.11
BuildRequires: 	ocaml-ppx_driver-devel >= 0.10
BuildRequires:	ocaml-ppx_driver-devel < 0.11
BuildRequires: 	ocaml-ppx_fields_conv-devel >= 0.10
BuildRequires: 	ocaml-ppx_fields_conv-devel < 0.11
BuildRequires: 	ocaml-ppx_js_style-devel >= 0.10
BuildRequires: 	ocaml-ppx_js_style-devel < 0.11
BuildRequires: 	ocaml-ppx_sexp_conv-devel >= 0.10
BuildRequires: 	ocaml-ppx_sexp_conv-devel < 0.11
BuildRequires: 	ocaml-ppx_sexp_value-devel >= 0.10
BuildRequires: 	ocaml-ppx_sexp_value-devel < 0.11
BuildRequires: 	ocaml-ocaml-migrate-parsetree-devel >= 0.4

%description
This library provides generic parsers for parsing S-expressions from
strings or other medium.

The library is focused on performances but still provide full generic
parsers that can be used with strings, bigstrings, lexing buffers,
character streams or any other sources effortlessly.

It provides three different class of parsers:
- the normal parsers, producing [Sexp.t] or [Sexp.t list] values
- the parsers with positions, building compact position sequences so
  that one can recover original positions in order to report properly
  located errors at little cost
- the Concrete Syntax Tree parsers, produce values of type
  [Parsexp.Cst.t] which record the concrete layout of the s-expression
  syntax, including comments

This library is portable and doesn't provide IO functions. To read
s-expressions from files or other external sources, you should use
parsexp_io.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires: 	ocaml-base-devel >= 0.10
Requires: 	ocaml-base-devel < 0.11
Requires: 	ocaml-ppx_compare-devel >= 0.10
Requires: 	ocaml-ppx_compare-devel < 0.11
Requires: 	ocaml-ppx_driver-devel >= 0.10
Requires:	ocaml-ppx_driver-devel < 0.11
Requires: 	ocaml-ppx_fields_conv-devel >= 0.10
Requires: 	ocaml-ppx_fields_conv-devel < 0.11
Requires: 	ocaml-ppx_js_style-devel >= 0.10
Requires: 	ocaml-ppx_js_style-devel < 0.11
Requires: 	ocaml-ppx_sexp_conv-devel >= 0.10
Requires: 	ocaml-ppx_sexp_conv-devel < 0.11
Requires: 	ocaml-ppx_sexp_value-devel >= 0.10
Requires: 	ocaml-ppx_sexp_value-devel < 0.11
Requires: 	ocaml-ocaml-migrate-parsetree-devel >= 0.4

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n %{ocamlname}-v%{version}

%build
jbuilder build  -p %{ocamlname} %{?_smp_mflags}

%install
opam-installer \
	--prefix=%{buildroot}/%{_libdir}/ocaml \
	--libdir=%{buildroot}/%{_libdir}/ocaml \
	%{ocamlname}.install

%files
%doc %{_libdir}/ocaml/doc/%{ocamlname}/LICENSE.txt
%{_libdir}/ocaml/%{ocamlname}
%ifarch %{ocaml_native_compiler}
%exclude %{_libdir}/ocaml/%{ocamlname}/*.a
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmxa
%exclude %{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%exclude %{_libdir}/ocaml/%{ocamlname}/*.mli

%files devel
%doc %{_libdir}/ocaml/doc/%{ocamlname}/README.org
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{ocamlname}/*.a
%{_libdir}/ocaml/%{ocamlname}/*.cmxa
%{_libdir}/ocaml/%{ocamlname}/*.cmx
%endif
%{_libdir}/ocaml/%{ocamlname}/*.mli
